//
// Copyright (C) 2008 Institut fuer Telematik, Universitaet Karlsruhe (TH)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

/**
 * @file BootstrapList.h
 * @author Ingmar Baumgart
 */


#ifndef __BOOTSTRAPLIST_H_
#define __BOOTSTRAPLIST_H_


#include <BaseOverlay.h>
#include <BaseRpc.h>
#include <BaseLookup.h>
#include <NodeVector.h>
#include <CommonMessages_m.h>

class BaseOverlay;
class BaseRpc;

class BootstrapList : public cSimpleModule
{
    
  public:
    BootstrapList();
    ~BootstrapList();
    void insertBootstrapNode(const NodeHandle& node);
    
  protected:
    virtual CompType getThisCompType() { return BOOTSTRAPLIST_COMP; };
      
  private:    
    void initialize(int stage);
    int numInitStages() const;
    void finish();
    void handleMessage(cMessage *msg);
    void handleBootstrapListTimerExpired();
        
    static const int timerInterval = 10;
    
    BaseOverlay* overlay;
    cMessage* timerMsg;
};

#endif
