//
// Copyright (C) 2008 Institut fuer Telematik, Universitaet Karlsruhe (TH)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

/**
 * @file OverlayAccess.h
 * @author Ingmar Baumgart
 */

#ifndef __OVERLAY_ACCESS_H__
#define __OVERLAY_ACCESS_H__


#include <omnetpp.h>

class BaseOverlay;

/**
 * Gives access to the overlay.
 */
class OverlayAccess
{
public:
    BaseOverlay* get
        (cModule* refMod)
    {
        BaseOverlay* overlay = NULL;
        cModule* tmpMod = refMod;

        while (overlay == NULL) {
            cModule* subMod = tmpMod->submodule("overlay");
            if (subMod != NULL) {
                overlay = dynamic_cast<BaseOverlay*>(tmpMod->parentModule()->
                        submodule("overlay"));
                if (overlay == NULL) {
                    cGate* tmpGate = subMod->gate("from_app");
                    if (tmpGate != NULL) {
                        overlay = dynamic_cast<BaseOverlay*>(tmpGate->
                                destinationGate()->ownerModule());
                    }
                }

            }
            tmpMod = tmpMod->parentModule();
            if (tmpMod == NULL) {
                throw new cException("OverlayAccess::get(): Overlay module "
                                     "not found!");
            }
        }
        return overlay;
    }
};

#endif
