#include "NodeLogEntry.h"
NodeLogEntry::NodeLogEntry() {

}

NodeLogEntry::NodeLogEntry(double timeStamp,char type, int subSpaceId, IPAddress ip1, IPAddress ip2, bool suc) {
	this->timeStamp = timeStamp;
	this->type = type;
	this->subSpaceId = subSpaceId;
	this->ip1 = ip1;
	this->ip2 = ip2;
	this->suc = suc;
}

NodeLogEntry::NodeLogEntry(double timeStamp,char type, int subSpaceId, IPAddress ip1, IPAddress ip2, double lastMessage, bool suc) {
	this->timeStamp = timeStamp;
	this->type = type;
	this->subSpaceId = subSpaceId;
	this->ip1 = ip1;
	this->ip2 = ip2;
	this->misc2 = lastMessage;
	this->suc = suc;
}
NodeLogEntry::NodeLogEntry(double timeStamp,char type, int subSpaceId, IPAddress ip1, IPAddress ip2, double misc1, double misc2) {
	this->timeStamp = timeStamp;
	this->type = type;
	this->subSpaceId = subSpaceId;
	this->ip1 = ip1;
	this->ip2 = ip2;
	this->misc1 = misc1;
	this->misc2 = misc2;
}
NodeLogEntry::NodeLogEntry(double timeStamp,char type, int subSpaceId, IPAddress ip1, IPAddress ip2, double misc1) {
	this->timeStamp = timeStamp;
	this->type = type;
	this->subSpaceId = subSpaceId;
	this->ip1 = ip1;
	this->ip2 = ip2;
	this->misc1 = misc1;
}
NodeLogEntry::NodeLogEntry(double timeStamp,char type, int subSpaceId, IPAddress ip1) {
	this->timeStamp = timeStamp;
	this->type = type;
	this->subSpaceId = subSpaceId;
	this->ip1 = ip1;
}
std::ostream& operator<<(std::ostream& Stream, const NodeLogEntry nl)
{
	Stream << "["<< nl.timeStamp <<"] ";
	switch ( nl.type ) {
		case 1: { Stream <<"Created Responsible Node for SubSpace " << nl.subSpaceId << " It was: " << nl.suc << " \n"; break; }
		case 2: { Stream << "Created Backup Node for SubSpace " << nl.subSpaceId << " . ResponsibleNodeIP: " << nl.ip1 << " I'm " << nl.ip2 << "It was: " << nl.suc << " \n"; break; }
		case 3: { Stream << "Created Intermediate node for SubSpace " << nl.subSpaceId << " . ResponsibleNodeIp: " << nl.ip1 << " I'm " << nl.ip2 << "It was: " << nl.suc << "\n"; break; }
		
		case 11: { Stream << "Deleted Responsible Node SubSpaceId " << nl.subSpaceId << " requested by " << nl.ip1 << " It was " << nl.suc <<"\n"; break;}
		case 12: { Stream << "Deleted Backup Node SubSpaceId " << nl.subSpaceId << " requested by " << nl.ip1 << " . Responsible Node has " << nl.ip2 << " last message was received " << nl.misc2 << " It was: " << nl.suc << " \n";break; }
		case 13: { Stream << "Deleted Intermediate Node SubSpaceId " << nl.subSpaceId << " requested by " << nl.ip1 << " ResponsibleNode has " << nl.ip2 << " . I had " << nl.misc1 << " Players in my List. It was: "<< nl.suc << "\n"; break; }
		
		case 20: { Stream << "Initiated Replace of Intermediate Node for SubSpaceId " << nl.subSpaceId << " replacing: " << nl.ip1 << " ResponsibleNode " << nl.ip2 << " my delay: " << nl.misc1 << " to replace delay: " << nl.misc2 << "\n"; break; }
		case 21: { Stream << " Got a new Backup Node for SubSpace: " << nl.subSpaceId << " Its IP: " << nl.ip1 << " old one:" << nl.ip2 << "\n"; break; }
		case 22: { Stream << "Requested new Backup Node for SubSpaceId: " << nl.subSpaceId << " old Ip: " << nl.ip1 << "\n"; break; }
		case 23: { Stream << "Requested new Intermediate Node for SubSpaceId " << nl.subSpaceId << "\n"; break; }
		case 24: { Stream << "Got a new Intermediate Node for SubSpace: " << nl.subSpaceId << " Its Ip: " << nl.ip1; break; }
		case 25: { Stream << "Replacing Intermediate Node SubSpaceId: " << nl.subSpaceId << "oldIp: " << nl.ip1 << " newIp: " << nl.ip2 << " . Sending " << nl.misc1 << " PlayerIps to the new IntermediateNode\n"; break; }
		case 26: { Stream << "Requesting deletion of IntermediateNode for SubSpaceId " << nl.subSpaceId << " IP: " << nl.ip1 << "\n"; break; }
		case 27: { Stream << "Replacing ResponsibleNode Id: " << nl.subSpaceId << " Old Ip: " << nl.ip1 << " PingDestip: " << nl.ip2 << "Sending ReplaceMsg to " << nl.misc1 << " Players \n"; break; }
		case 30: { Stream << "Ping failed: " << nl.ip1 << " . #: "<< nl.misc1 <<"\n"; break; }
		case 31: { Stream << "Create failed: " << nl.ip1 << " .#: "<< nl.misc1 << " SubSpaceId: " <<nl.subSpaceId << " NodeType: " << nl.misc2 << "\n";break;}
		case 32: { Stream << "SubScribe failed: " << nl.ip1 << " .#: " << nl.misc1 << " SubSpaceId: " << nl.subSpaceId << " PlayerId: " << nl.misc2; break; }
		case 33: { Stream << "UnSubScribe failed: " << nl.ip1 << " .#: " << nl.misc1 << " SubSpaceId: " << nl.subSpaceId << " PlayerId: " << nl.misc2; break; }
		
		default: Stream << "Unknown Log Entry\n";
	}
	return Stream;
}

