//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
#ifndef __SUBSPACE_H_
#define __SUBSPACE_H_

#include <string>
#include <vector>
#include "GameState.h"
#include <IPAddress.h>
#include <iostream>

enum Direction
{
	NW = 0,
	N  = 1,
	NE = 2,
	W  = 3,
	E  = 4,
	SW = 5,
	S  = 6,
	SE = 7
};

class SubSpace {
	public:
		SubSpace();
		SubSpace(int id);
		SubSpace(int id, IPAddress resp_id);
		SubSpace(int id, IPAddress resp_id, IPAddress backup_ip);
		int getId() const;
		void setId(int id);
		IPAddress getRespIp() const;
		void setRespIp(IPAddress resp_ip);
		IPAddress getBackupIp() const;
		void setBackupIp(IPAddress backup_ip);
		GameState getGameState() const;
		void setGameState(GameState gamestate);
		IPAddress getNeighbor(int direction) const;
		void setNeighbor(int direction, IPAddress resp_ip);
		friend std::ostream& operator<<(std::ostream& Stream,const SubSpace S);
		int getTimeSlot();
		void setTimeSlot(int timeSlot);
	protected:
	private:
		int id;
		int timeSlot;
		IPAddress resp_ip;
		IPAddress backup_ip;
		GameState gamestate;
		IPAddress neighbors[8];
};

#endif
