#ifndef __PENDINGMESSAGES_H_
#define __PENDINGMESSAGES_H_

#include <iostream>
#include <IPvXAddress.h>
#include "Event.h"
#include "SubSpace.h"
#include "PlayerNode.h"
#include <list>
#include <vector>

class OpenLogin {
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenLogin ol);
	bool operator<(const OpenLogin ologin) const;
	double timeStamp;
	int playerid;
	IPAddress playerip;
	int bandwith;
	int cpu;
	int x;
	int y;
	std::list<int> missingSubSpaces;
	std::vector<int> readySubSpaces;
	int failed;
	private:
};

class OpenCreate {
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenCreate ol);
	bool operator<(const OpenCreate ocreate) const;
	double timeStamp;
	IPAddress destip;
	int nodeType;
	int jobType;
	int subSpaceId;
	int failed;
	private:
};

class OpenEvent {
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenEvent openEvent);
	bool operator<(const OpenEvent openEvent) const;
	double timeStamp;
	int playerId;
	int subSpaceId;
	Event event;
	int failed;
};

class OpenSubscribe {	
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenSubscribe openSubscribe);
	bool operator<(const OpenSubscribe openSubscribe) const;
	double timeStamp;
	int playerId;
	IPAddress playerip;
	int subSpaceId;
	IPAddress destip;
	int failed;
};

class OpenUnSubscribe {
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenUnSubscribe openUnSubscribe);
	bool operator<(const OpenUnSubscribe openUnSubscribe) const;
	double timeStamp;
	int playerId;
	IPAddress playerip;
	int subSpaceId;
	IPAddress destip;
	int failed;
};

class OpenRequestIp {
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenRequestIp openRequest);
	bool operator<(const OpenRequestIp openRequest) const;
	double timeStamp;
	int subSpaceId;
	int nodeType;
	IPAddress requestedIp;
	IPAddress destip;
	int failed;
};

class OpenUpdateRespIp {
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenUpdateRespIp openUpdate);
	bool operator<(const OpenUpdateRespIp openUpdate) const;
	double timeStamp;
	int subSpaceId;
	int nodeType;
	int direction;
	IPAddress updatedIp;
	IPAddress destip;
	int failed;
};	

class OpenPublishEventList {
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenPublishEventList openPublishEventList);
	bool operator<(const OpenPublishEventList openPublishEventList) const;
	double timeStamp;
	int timeSlot;
	int subSpaceId;
	int serviceType;
	IPAddress destip;
	std::vector<Event> eventList;
	int failed;
};	
	
class OpenPing {
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenPing openPing);
	bool operator<(const OpenPing openPing) const;
	double timeStamp;
	IPAddress destip;
	int failed;
};

class OpenPlayerList {
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenPlayerList openPlayerList);
	bool operator<(const OpenPlayerList openPlayerList) const;
	double timeStamp;
	int subSpaceId;
	int action;
	PlayerNode player;
	int failed;
};

class OpenRequestNode {
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenRequestNode openRequestNode);
	bool operator<(const OpenRequestNode openRequestNode) const;
	double timeStamp;
	int subSpaceId;
	int nodeType;
	int failed;
};

class OpenReplacement {
	public:
	friend std::ostream& operator<<(std::ostream& Stream,const OpenReplacement openReplacement);
	bool operator<(const OpenReplacement openReplacement) const;
	double timeStamp;
	int subSpaceId;
	int sendGameState;
	IPAddress destip;
	int failed;
};	

#endif
